import Missing
import datetime
from z3c.relationfield import RelationValue
from z3c.relationfield.schema import RelationList
from plone.app.textfield.value import RichTextValue
from DateTime import DateTime
import logging


logger = logging.getLogger("Plone")


def pac_utils_custom_json_handler(obj):
    # logger.info('%s custom_json_handler called' % get_linenumber())
    logger.info(type(obj))
    if obj == Missing.Value:
        return None
    if type(obj) in (datetime.datetime, datetime.date):
        return obj.isoformat()
    if type(obj) == DateTime:
        dt = DateTime(obj)
        return dt.ISO()
    if type(obj) == set:
        return list(obj)
    # 20170418 fixed Circular reference
    # return the id of the related object(s)
    if type(obj) == RelationValue:
        print ("obj is RelationValue" , obj)
        return obj.to_path.split('/')[-1]
    if type(obj) == RelationList:
        print ("obj is RelationList" , obj)
        return list(item.to_path.split('/')[-1] for item in obj)
    if type(obj) == RichTextValue:
        print ("obj is RichTextValue" , obj)
        logger.info(obj.output)
        return obj.output
    return obj
